#ifndef _DLP_KIT_H
#define _DLP_KIT_H

#include <hush/kit.h>
#include <dlp/dlp.h>


#ifndef foreign
#ifndef no_foreign
extern int dlp_callback_function( dlp* );
#include <stdlib.h>
#define foreign(X) int X(dlp* x) { \
	cerr << "WARNING: calling dummy foreign" << endl; \
	exit(1); \
	return 0; \
	}
#endif
#endif

class dlp_kit : public kit {
public:

char* category() const { return "dlp"; }
char* info() const { return "dlp_kit"; }

//dlp_kit(void*);
dlp_kit();
~dlp_kit();

int operator()();
int schedule(int period, handler* = 0, int cycles = 0, int slices = 0); // 0 = default!

int eval(const char* cmd);

// char* evaluate(const char* cmd);
// 
// char* result() const;
// void result(const char* s);
// 
// int source(const char* f);
// 
// int error(); /// NEW
// void error(const char*); // NEW
// 
// void after(int n, const char* cmd="");
// void after(int n, void*, void* = 0);
// void after(int n, handler* h);
// 
// char* send(const char* it, const char* cmd);
// 
// char* selection(const char* options="") const;
// 
// void update(const char* options="");
// 
// int safe() const;
// kit* slave(char* options = "");
// 
// 
// void unbind(int fd);
// void unbind(char* name, char* newname = "");
// 
// dvbinding* bind(const char* name);

dvbinding* bind(const char* name, handler* h, void* f = 0);

// dvbinding* bind(const char* name, void* proc , void* data = 0);
// 
// dvbinding* bind(handler* h);
// dvbinding* bind(void* proc , void* data = 0);
// 
// dvbinding* bind(int fd, handler* h, int mask=readable); // jrvosse
// 
// void command(const char* name, void*, void*); /// NEW
// void command(int fd, void*, void* =0, int mask=readable); 		          // jrvosse
// 
// 
// void quit();
// 
// void trace(int i = 1);
// void notrace();
// 
// event* get() const;
// 
// widget* root() const; 
// widget* pack(class widget* w, const char* options = "-side top -fill x");
// widget* pack(const char* w, const char* options = "-side top -fill x");
// 
// //// Experimental
// 
// void font(char*);
// int alias( char*, handler* );
// 
// 
// /// not for public use, will be changed to protected
// 
// int callback(void*,void*,int,char**);
// void* interp() const; /// the interpreter, whatever it is
// void* tkwin() const;  /// returns the root window
// void put(event* p, int fl = 0); /// to update events

protected:

class dlp*  dp;
char* buf;
kit* tk;

int _period;
handler* _handler;
int _slices;
int _cycles;
};



#endif
