// Engine.h
//
// This class provides access to a Prolog engine. Its main purpose
// is to dynamically add facts and execute queries.
//
// Author : Martijn van Welie
//

#ifndef ENGINE_H
#define ENGINE_H

#include "Term.h"

class Engine {
public:
	Engine();
	~Engine();

	// Feed the engine
	void 	Load(const char* fileName);
	void	Restart();
	int	Assert(Term &t);

	// Simple queries, one solution
	int	Query(Term &t);
	int 	queryCutFail(Term &t);

	// Finding all solutions
	void	openQuery(Term &t);
	int	nextSolution();
	int	closeQuery();

	// Debugging
	char*	getError();
	char*	getException();
protected:
	char	m_fileName[MAX_BUF_LEN];
	char	m_buf[MAX_BUF_LEN];
	SP_qid	m_goal;
private:

};

#endif
