#ifndef _TCL_KIT_H
#define _TCL_KIT_H

#include <hush/kit.h>

class tcl_kit : public kit {
static int _no;
public:

char* info() const { return "tcl_kit"; }

tcl_kit(void*);
tcl_kit();
~tcl_kit();

int eval(const char* cmd);
char* evaluate(const char* cmd);

char* result() const;
void result(const char* s);

int source(const char* f);

int error(); /// NEW
void error(const char*); // NEW

void after(int n, const char* cmd="");
void after(int n, void*, void* = 0);
void after(int n, handler* h = 0);

void* token() const; /// last TimerToken 

char* send(const char* it, const char* cmd);

char* selection(const char* options="") const;

void update(const char* options="");

int safe() const;
kit* slave(char* options = "");


void unbind(int fd);
void unbind(char* name, char* newname = "");

dvbinding* bind(const char* name);
dvbinding* bind(const char* name, handler* h);
dvbinding* bind(const char* name, void* proc , void* data = 0);

dvbinding* bind(handler* h);
dvbinding* bind(void* proc , void* data = 0);

dvbinding* bind(int fd, handler* h, int mask=readable); // jrvosse

void command(const char* name, void*, void*); /// NEW
void command(int fd, void*, void* =0, int mask=readable); 		          // jrvosse


void quit();

event* get() const;

/// not for public use, will be changed to protected

int callback(void*,void*,int,char**);
void* interp() const; /// the interpreter, whatever it is
void put(event* p, int fl = 0); /// to update events

protected:
char* buf;
private:
int _trace;
void* _last;
int _type;
widget* _root;
void* _interp;
};



#endif
