#ifndef PLUGIN_H
#define PLUGIN_H

#ifdef PLUGIN

#include <hush/hush.h>
#include <hush/session.h>
#include <widgets/button.h>
#include <widgets/message.h>
#include <dv/tk/kit.h>
#include <dv/tk/tk.h>

#include <tk.h>

#include <dv/tcl/applet.h>

#ifdef APPLET
#define PLUGIN APPLET
#endif

#if defined(PLUGIN) || defined(MODULE)
#define swig_concat(X,Y,Z) X##Y##Z

#ifndef MODULE
#define MODULE PLUGIN
#endif

#ifdef PLUGIN
#define SAFE_SWIG
#endif

#define PLUGINIT(X) swig_concat(X,_,SafeInit)
#define MODULEINIT(X) swig_concat(X,_,Init)

#define APPLETMAIN(X) swig_concat(X,_,main)
#define INITMODULE(X) swig_concat(init,_,X)
#define APPLICATION(X) swig_concat(X,_,application)

extern void INITMODULE(MODULE)();
extern  void* swig_interp();

#ifdef PLUGIN
#ifndef COMMAND
#define COMMAND "init_applet"
#endif
#include <dv/tcl/swigplug.h>
#endif
#endif


class plugin_session : public session {
public:

plugin_session(int, char**, const char* name = "plugin") : session(this) {
if (name);
tk = new tk_kit(swig_interp());
//tk->command("menu", (void*) Tk_MenuCmd,0);
kit::_default = tk;
tk = new kit();
kit::declare("tk",tk);
kit::declare("tcl",tk);
session::declare("global",this);
session::initialize();
dvtk::xtracer(tk);
//tk->eval("set hush_library /home/eliens/dv/hush/lib/hush");
}


void prelude() {
	button* b = new applet_handler("b");
	_register(b);
	}

// The application


virtual int APPLETMAIN(MODULE)() {
	return main();
	}

virtual int main() {
	message* error = new message(".error");
	error->text("Error: main not defined");
	error->pack();
	return -1;
	}

virtual int run( int proc(class kit*,int,char**) = 0 ) {
	proc = 0;
	this->prelude();
	return this->APPLETMAIN(MODULE)();
	}
};




#if defined(PLUGIN) || defined(MODULE)

#define session plugin_session
#define main APPLETMAIN(MODULE)
#define application APPLICATION(MODULE)

extern int APPLETMAIN(MODULE)(int, char* argv[]);

#ifndef INIT
void INITMODULE(MODULE)() {
#else
void init_##INIT() {
#endif
	APPLETMAIN(MODULE)(0,0);
	}

#endif

#endif
#endif
