#ifndef _TK_KIT_H
#define _TK_KIT_H

#include <dv/tcl/kit.h>

class tk_kit : public tcl_kit {
static int _no;
public:

char* info() const { return "tk_kit"; }

tk_kit(void* x);
tk_kit();
~tk_kit();



char* selection(const char* options="") const;
void update(const char* options="");

dvbinding* bind(const char* name, handler* h); // tk_event::callback

dvbinding* bind(const char* name) { return tcl_kit::bind(name); }
dvbinding* bind(const char* name, void* proc , void* data = 0) {
	return tcl_kit::bind(name,proc,data);
	}
 
dvbinding* bind(handler* h);
dvbinding* bind(void* proc, void* data=0) {
	return tcl_kit::bind(proc,data);
	}

dvbinding* bind(int fd, handler* h, int mask) {
	return tcl_kit::bind(fd,h,mask);
	}

widget* root() const; 
widget* pack(class widget* w, const char* options = "-side top -fill x");
widget* pack(const char* w, const char* options = "-side top -fill x");

//// Experimental

void font(char*);
int alias( char*, handler* );


/// not for public use, will be changed to protected

void* tkwin() const;  /// returns the root window

public:
static int initialized;
static int initialize();


private:
widget* _root;
};



#endif
