#ifndef AGENT_H
#define AGENT_H

#include <hush/export.h>
#include <hush/event.h>

class locator;
class finder;
class resolver;
class loader;

///@class agent

class HUSH_API agent : public event {
public:

agent(const char* kind = 0);

void lookin(const char* dir); // add to search path for finder

char* source(const char* url);
int load(const char* url);

//void  consult(const char* url);
//term* query(const char* cmd); 

void alias(const char* k, const char* v);
char* alias(const char* k);

char* marked(const char* k);
void mark(const char* k, const char* v = "marked");

protected:
agent* _agent;

locator*  _locator;
finder*   _finder;
resolver* _resolver;
loader*   _loader;

public:
static agent* _default;

static void set_default(agent* x); // { _default = x; }
static agent* get_default(); // { return _default; }

static int created;
static int deleted;

static void* table;
static void declare(const char*, void*, int flag = 0);
static agent* lookup(const char*);
static void destroy();
};

///</>

#endif
