#ifndef _hush_agent_query_h
#define _hush_agent_query_h

#include <hush/kit.h>

class session;
class dvstring;
class term;

class HUSH_API dvquery : public kit {
static int no;
char _command[1024*2];
int _exec;
session* _session;
int _prepared;
char _id[64];
public:
static int nodebug;

dvquery(int argc,  char* argv[]);
dvquery(const char* args = 0);
~dvquery();

virtual char* id();
virtual void init(int argc, char* argv[]);


char* category() const;

int operator()();

int source(const char* arg);

long eval(const char* arg);
char* result(long id=0);
void  result(const char*);
char* evaluate(const char*);

virtual char* ask(const char*);
virtual void halt();

virtual void _assert(const char* x, const char* opt="");
virtual void _retract(const char* x, const char* opt="");

dvbinding* bind(const char* name, handler* h);
dvbinding* bind(handler* h); // anonymous
dvbinding* bind(int fd, handler* h, int mask=kit::readable); // jrvosse


void option(const char* k, const char* v);
char* option(const char* p);

public:
virtual int prepare();

virtual void _send(const char* mode, const char* value);
virtual void _reset(const char* mode);

private:
void _init();
void peek();

private:
void* _state;
dvquery* _query;
kit* _kit;
int _once;
int _result;
char* _peek;
handler* _handler;

public:
static dvquery* _default;

static int created;
static int deleted;

static void* table;
static void declare(const char*, void*, int flag = 0);
static dvquery* lookup(const char*);
static void destroy();
};

#ifndef query
#define query dvquery
#endif

#endif
