#ifndef _query_srv_h
#define _query_srv_h

#include <hush/query.h>

//#include <hush/api/srv/handler.h>
#include <hush/srv.h>

#include <stdio.h>

class query_srv : _crob(hush,query), srv< query > {
public:
    query_srv(query* q, query* m = 0) : srv< query >(q) {
	_halt = 0; _ask = 0; _query = q; _master = m;
	}

    virtual void source(const char* f) { _query->source(f); }

    virtual corba::integer eval(const char* cmd) {
	if (_master) _master->_reset("ans");
	return (corba::integer) _query->eval(cmd);
	}

    virtual char* result(corba::integer id) {
	char* p = _query->result((long) id);
        if (!p) p = "false";
        if (_master) _master->_send("ans",p);
        corba::string_var _result = (const char*) p;
        return result_string(_result);
	}

    virtual char* ask(const char* s) {
	char buf[256];
        sprintf(buf,"ask(%d,%s)",_ask++ % 2,s);
        if (_master) _master->_send("ask",buf);
        if (_master) _master->_reset("ans");
        int res = _query->eval(buf);
        char* p = _query->result(res);
        if (!p) p = "false";
        if (_master) _master->_send("ans",p);
        if (!strcmp(p,"halt")) _halt = 1;
        corba::string_var _result = (const char*) p; // const is needed
        return result_string(_result);

	}

    virtual void halt() { // must check for authorization
	if (_halt == 1) {
		cerr << "Ending query server" << endl;
		delete session::_default;
		session::statistics();
		exit(0);
		}
	}
private:
int _ask;
int _halt;
query* _query;
query* _master;
};

#endif
