#ifndef HUSH_EVENT_H
#define HUSH_EVENT_H

#include <hush/export.h>

class widget;
class kit;
class event;
class histogram;

// the event class is an overloaded entityy -- should it be fat or lean?

#include <hush/handler.h>


class HUSH_API event  : public handler {  	// man:event(4)
int _del;
public:

enum { user = 0, system = 1, tcl, file, tt, Sim };  // obsolete

public: // should be protected, and may be will be

	event(kit*,int,char**);             // script (tcl)
	
	event(int qp=0,int sp=0,int k=0);   // event::_create  (sim)
	
	event(const char* s);               // modeling 
	event(const event&);
	
	// cloning
	
	virtual event* create(kit*,int,char**);
	
	// to allow for object references
	
	event(event*);                       
	virtual ~event();     
	
	// dispatching 

	virtual int operator()();

public:    // common methods 

virtual int eventclass() const ; 	// defaults to 0 = user

virtual int type() const;   		// defaults to 0 

virtual char* name() const ; 

virtual void trace() const; 

// To obtain 'the' event, allows for 'type secure' event handling

virtual event* get() const; 		// obsolete

// obsolete

virtual int no() const;
virtual char* id() const;

// etelosbo

public: //@ Tcl/Tk

virtual int argc() const;
virtual char** argv(int i = 0) const;
virtual char* arg(int i = 0) const;
virtual char* args(int i = 0, int q = 1) const; // quoted by default

virtual int fd() const;
virtual int mask() const;

public: //@ logic events

virtual char* ask();
virtual void  tell(const char* msg);

virtual long eval(const char* cmd);
virtual char* evaluate(const char* cmd);

virtual char* result(long id=0);
virtual void result(const char* s);

public: //@ tk & X event methods

virtual int x() const ;
virtual int y() const ;
virtual int x_root() const ;
virtual int y_root() const ;
virtual int button(int i = 0) const ;
virtual int buttonup(int i = 0) const ;
virtual int keycode() const ;
virtual int buttonevent(int i = 0) const ;
virtual int keyevent() const ;
virtual int motion() const ;
virtual void motion( event& );
virtual void* rawevent() ;

public: //@ simevent -- for simulation <hush/sim/event.h> 

virtual int report(histogram* hi,double interv = 0);
virtual void stamp();
virtual double timespent();

virtual char* reporttitle();
virtual double time() const;
virtual void time(double t);
virtual int schedulingpriority();
virtual void schedulingpriority(int p);
virtual int queuingpriority();
virtual void queuingpriority(int p);
virtual double interval();
virtual void interval(double i);
virtual int state();
virtual void state(int s);
virtual int killflag();
virtual event* leftpointer();
virtual void leftpointer(event*);
virtual event* middlepointer();
virtual void middlepointer(event*);
virtual event* rightpointer();
virtual void rightpointer(event*);
virtual event* parentpointer();
virtual void parentpointer(event*);
virtual double waitingreporttime();
virtual void waitingreporttime(double);
virtual double eventreporttime();
virtual int _active();
virtual int pending();
virtual int conditional();
virtual int closed();
virtual int passive();
virtual int queued();

public: //@ native logic events

virtual char* _box();   // prolog box call redo cut fail model
virtual char* _process();
virtual char* _thread();

virtual char* _instream();
virtual char* _outstream();

virtual char* _class();
virtual char* _object();
virtual char* _objectid();
virtual char* _reference();
virtual char* _pointer();
virtual char* _ior();
virtual char* _method();

virtual char* _variable();
virtual char* _constraint();
virtual char* _relation();

public: //@ for sgml events  

virtual char* _tag() const;
virtual char* _attributes() const;
virtual char* _data() const;



private: //@ ...
int exists() const; /// to check for circularity;
event* _body;
public:
static void* _last;    // to store the last event
static void set_last(void*);    // to store the last event
static void* give_last();    // to store the last event
static void* _create;  // to create sim_event body

public: //@ defaults
static int created;
static int deleted;

static void* table;
static void declare(const char*, void*, int flag = 0);
static event* lookup(const char*);
static void destroy();
};

#endif
