#ifndef _hush_api_io_h
#define _hush_api_io_h

#include <iostream.h>

class hush_ostream : public ostream {
public:

hush_ostream(ostream* os);
hush_ostream(int os);

hush_ostream& operator<<(ostream& (*)(ostream&));

hush_ostream& operator<<(int x);
hush_ostream& operator<<(double x);
hush_ostream& operator<<(const char* x);

private:
int id;
char* _buf;
ostream* _out;

public:
static int no;
static int pr;

static hush_ostream* coutp;
static hush_ostream* cerrp;

static int created;
static int deleted;

static void* table;
static void declare(const char*, void*, int flag = 0);
static hush_ostream* lookup(const char*);
static void destroy();

public:
static int initialized;
static int initialize();
};

#ifndef WIN32
#ifndef cout 
#define cout (*hush_ostream::coutp)
#endif

#ifndef cerr 
#define cerr (*hush_ostream::cerrp)
#endif

#ifndef ostream
#define ostream hush_ostream
#endif

#endif
#endif
