#ifndef SESSION_H
#define SESSION_H

#include <hush/export.h>
#include <hush/handler.h>

class kit;

class HUSH_API session : public handler  {  	// man:session(4)
  protected:
    session(session*);
  public:
    session(const char* kind = "hush", int flags = 0 );
    session(int argc, char* argv[], const char* name = "hush", int fl=0);
    // putting 0 for name disables window mapping	

    virtual int create(int , char**, const char*, int fl); // for subs
    
    virtual ~session();

    virtual int tracelevel() const;
    virtual void  trace(int = 1);
    
    virtual void prelude();
    virtual int main();
    
    virtual int run( int proc(::kit*,int,char**) = 0 );

    static void statistics(char* s = 0);

public: //@ loading dependencies  -- <tt>"hush:dv:widgets"</tt>

    virtual void depends(const char* s = 0); // default "hush:dv:widgets"
    virtual int load(const char* s);
    
public: //@ are you experienced?
    
    virtual void init(const char* fname, void* = 0);
    virtual void install(void* = 0);
    
    virtual int mode() const;
    virtual int mode(int fl);
    virtual int mode(const char* = 0);
    
    virtual int loop(int fl=0);
    virtual int body(int fl=0);
    
    virtual void map(int fl=0); // redefine map to disable window
    
    kit* thekit() const;
    
    virtual double clock() const;
    virtual double clock(double);
    
    virtual double time() const;
    virtual void time(double) { }

private: //@ ...
    void* _state;

public: 
static char* _depends;  	// for dynamic loading

static int _trace;
static int do_quit();
static void set_quit(int);
static int _quit;
static int _nowin;
static int has_nowin();

static int _java;
static int _corba;

public: //@ defaults

static int initialized;
static int initialize();


static session* _default;
static void* _create; 


static void set_default(session* x); // { _default = x; }
static session* get_default(); // { return _default; }

static int created;
static int deleted;

static void* table;
static void declare(const char*, void*, int flag = 0);
static session* lookup(const char*);
static void destroy();

static char* version();
static int compilerflags();
};

#endif
