#ifndef _hush_corba_orb_ooc_broker_h
#define _hush_corba_orb_ooc_broker_h

#include <hush/agent/broker.h>

#include <OB/CORBA.h>
#include <OB/Util.h>

#include <hush/corba/orb/ooc/corba.h>

class ooc_broker : public broker {
public:

ooc_broker() {
	session::_default->_register(this);
	_broker = broker::lookup("orb"); 
	if (_broker) {
		_orb = (CORBA_ORB*) _broker->orb();
		_boa = (CORBA_BOA*) _broker->boa();
		}
	}

void init(int& argc, char**& argv, int fl=0) {
       if (!_broker) _broker = broker::lookup("orb");
       if (!_broker) {
		//load("orb");
		_broker = 0; // broker::lookup("orb");
		}
       if (!_broker) {
       		_orb = CORBA_ORB_init(argc, argv);
       		_boa = _orb -> BOA_init(argc, argv);
       		broker::declare("orb",this);
	} else {
		_orb = (CORBA_ORB*) _broker->orb();
		_boa = (CORBA_BOA*) _broker->boa();
		}
}


int operator()() {
        _boa -> impl_is_ready(CORBA_ImplementationDef::_nil());
	return 1;
	}


char* ref(corba::object* x) {
	_str = _orb -> object_to_string((CORBA_Object*)x);
	return (char*) _str;
	}

corba::object* ref(const char* s) {
	corba::object* objp = _orb -> string_to_object(s);
	return objp;
	}

corba::object* object(const char* f) {
	char* url = filein(f);
	return ref(url);
	}

void refout(const char* f, corba::object* x) {
	fileout(f,ref(x));
	}

void print(corba::exception& ex) {
	OBPrintException(ex);
	}

public: //@ dangerous

void* orb() { return (CORBA_ORB*) _orb; }
void* boa() { return (CORBA_BOA*) _boa; }

public:
broker* _broker;
CORBA_ORB_var _orb;
CORBA_BOA_var _boa;
CORBA_String_var _str;
};

#ifndef broker
#define broker ooc_broker
#endif

#endif
