#ifndef _dv_srv_dot_h
#define _dv_srv_dot_h

#include <hush/hush.h>
#include <hush/corba.h>
#include <hush/api/srv/hush.h>
#include <hush/api/srv/factory.h>

class hush_dot_srv : _crob(hush,dot) {
public:
    virtual hush::kit* kit(const char* name,ENV) {
	::kit* tk = kit::lookup(name);
	cerr << "Dotting kit " << name << endl;
	if (!tk) {
		tk = new ::kit(name);
		//_register(tk);
		}
	hush::kit* x = new kit_srv(tk);
	//hush::kit::_duplicate(x);
	x->_duplicate();
	return x;
	}

    virtual hush::container* container(const char* name,ENV) {
	//cerr << "Exporting list " << name << endl;
	hush::container* x = (hush::container*)  list<void>::lookup(name);
	if (!x) {
		//cerr << "Error: no list_srv " << name << endl;
		x = new list_srv<hush::handler>;
		}
	//cerr << "Export dupl " << endl;
	//hush::container::_duplicate(x);
	x->_duplicate();
	//cerr << "Exported list " << name << " " << x << endl; 
	return x;
	}

    virtual hush::iterator* iterator(const char* name,ENV) {
	iter<void>* it = iter<void>::lookup(name);
	hush::iterator* x = new iter_srv((iter<void>*)it);
	//hush::iterator::_duplicate(x);
	x->_duplicate();
	return x;
	}

    virtual hush::factory* hush(const char* name, ENV) {
	if (name); //Wall
	hush::factory* x = new hush_factory_srv();
	//hush::factory::_duplicate(x);
	x->_duplicate();
	return x;
    }
};

//DEF_TIE_hush_dot(dot)
//DEF_TIE_widgets_dot(dot)

#endif
