#include <hush/export.h>
#include <hush/handler.h>
#include <hush/agent.h>
#include <hush/io.h>
#include <hush/dictionary.h>
#include <hush/string.h>


class HUSH_API pl_source_handler : public handler {
dictionary<string>* _loaded;
public:

pl_source_handler(pl_kit* tk) {
	_tk = tk;
	if (!agent::get_default()) agent::set_default ( new agent()); 
	_loaded = new dictionary<string>(1);
	tk->_register(_loaded);
	}

int operator()() {
	char* s = _event->ask();
	if ( ! (*_loaded)[s] ) {
		char* f = agent::get_default()->source(s);
		(*_loaded)[s] = new string(f);
	        cerr << "pl_source_handler: " << s << " :" << f << endl;
		_tk->consult(f);
		}
	return OK;
	}

private:
pl_kit* _tk;
};

class pl_cout_handler : public handler {
public:

int operator()() {
	char* s = _event->ask();
	if (!strcmp(s,"nl"))
		cout << endl;
	else
		cout << s;
	return 0;
	}

};

class pl_cerr_handler : public handler {
public:

int operator()() {
	char* s = _event->ask();
	if (!strcmp(s,"nl"))
		cerr << endl;
	else
		cerr << s << endl;
	return OK;
	}

};
