#ifndef _hush_dv_pl_kit_h
#define _hush_dv_pl_kit_h

#include <hush/export.h>
#include <hush/kit.h>
#include <hush/dv/pl/pl.h>
#include <hush/term.h>
#include <hush/handler.h>
#include <hush/dictionary.h>


class pl_kit : public kit {
int _md;
public:

char* category() const { return "pl"; }
char* info() const { return "pl_kit"; }

pl_kit();
~pl_kit();

int operator()();
int schedule(int period, handler* = 0, int cycles = 0, int slices = 0); // 0 = default!

term* query(const char* pred, int md = 0);  // is mode dependent !
int  consult(const char* pred);

// old style

long eval(const char* cmd);
char* result(long id=0) ;
void result(const char* s);

int source(const char* f);

// for binding handlers


dvbinding* bind(const char* name, handler* h);
/*
dvbinding* bind(handler* h);
dvbinding* bind(int fd, handler* h, int mask=readable);
*/

public:
static int initialized;
static int initialize();


protected:

term* _result;
char* buf;
kit* tk;

int _period;
handler* _handler;
int _slices;
int _cycles;

public:
static dictionary<handler>* _handlers;
};

#endif
