#ifndef H_TERM_FORMATTER 
#define H_TERM_FORMATTER 

#include <hush/export.h>
#include <hush/handler.h>
#include <hush/term.h>
#include <hush/dictionary.h>

class dvstring;

class HUSH_API formatter : public handler {
public:

formatter(char* kind="ml");


virtual char* _format(const term*);

virtual char* get(const char* k, int arity = -1);
virtual void  format(const char* k, const char* fm);

protected:
formatter* _formatter;

virtual char* _buf();

public: //@ ...
static formatter* _default;
static void (*_init)(dictionary<dvstring>&);

static void defaults(const char* k, const char* f);

static handler* _garbage;
static void _cleanup();
static void _hold(const handler* h); 


static dictionary<dvstring>* _defaults; // defaults
dictionary<dvstring>* _formats;         // local refinements

public: //@ defaults
static int created;
static int deleted;

static void* table;
static void declare(const char*, void*, int flag = 0);
static formatter* lookup(const char*);
static void destroy();

static int initialized;
static int initialize();
};


class term_formatter : public formatter {
public:
term_formatter();
virtual char* _format(const term* t);
};
#endif
