#ifndef ML_TERM_H
#define ML_TERM_H

#include <hush/export.h>
#include <hush/term.h>


class HUSH_API ml_term : public term {
public:

enum { _con = 1, _var = 2, _fun = 3 };

ml_term();
ml_term(const char* f); // con or var
ml_term(const char* f, const term* t1, const term* t2 = 0);

~ml_term();

term* mk(const char* f) { return new ml_term(f); }
term* mk(const char* f, const term* t1, const term* t2 = 0) { return new ml_term(f,t1,t2); }


//virtual char* next();

// Value types
//// General

virtual int type() const;

virtual int nargs() const;
virtual int arity() const;
virtual int narity() const;

virtual char* fun() const;

virtual term* a1() const;
virtual term* a2() const;

virtual term* arg(int i = 0) const;
virtual term* nth(int i = 0) const;

virtual int _isnil(const char* s = 0) const;
virtual int _isnum(const char* s = 0) const;
virtual int _iscon(const char* s = 0) const;
virtual int _isvar(const char* s = 0) const;
virtual int _isfun(const char* s = 0) const;

virtual int _ismeta(const char* s = 0, int narg = -1) const;

//virtual char* id() const ;
virtual char* str(formatter* f = 0) const ;

public:
static formatter* _formatter;
static int formatted();

protected:

private:
int _tag;
int _varno;
char _f[64];
term* _a1;
term* _a2;
};

#endif
