// client.h
//
// header file for the dynamic role-switching client class
// the i n t e r f a c e for real clients (like http, ftp)
//
// September, October 1995, January 1996
// Bastiaan Sch\"onhage

#ifndef CLIENT_H
#define CLIENT_H

#include <hush/export.h>

#include <hush/hush.h>
#include <hush/bool.h>
#include <hush/dictionary.h>
#include <hush/net/client/MIME.h>
#include <fstream.h>

void HUSH_API init_client( kit* tk );  // to initialize the package

class HUSH_API dvclient {
      public:
	dvclient();	
//    	dvclient(const dvclient&) {};
//    	dvclient& operator=(const dvclient&) {};
	virtual ~dvclient();
	virtual const char* type(void) const;
	
	// build request
	virtual void get(const char* url);
	virtual bool send_request();
	

	// get reply
	virtual bool get_reply(char* &buffer, int &length);
	virtual bool get_reply_header(char* &buffer, int &length);
	virtual bool get_reply_body(char* &buffer, int &length);
	virtual bool get_reply_trailer(char* &buffer, int &length);
	

	// alternative reply , use get_reply() first
	virtual bool get_reply();		// use this first
	virtual bool get_reply_body(int &fd);	// body can be read using fd
	
	// info about reply
	virtual MIME* media();
	virtual int length(void);
	virtual int errorcode(void);
      protected:
	dvclient(int dummy);
	dictionary<dvclient> client_dict;
      private:
	dvclient* client_;
};

#ifndef client
#define client dvclient
#endif

#endif
