// file_client.h
//
// header file for the fileclient class
//
// October 1995
// Bastiaan Sch\"onhage

#ifndef FILE_CLIENT_H
#define FILE_CLIENT_H

#include <hush/net/client/url.h>
#include <hush/net/client/client.h>
#include <hush/net/client/MIME.h>

#include <stdio.h>
#include <hush/dictionary.h>


class file_client: public client {
      public:
	file_client();
	~file_client();
	const char* type(void) const;
	
	// build request
	void get(const char* url);
	bool send_request();
	
	// get reply
	bool get_reply(char* &buffer, int &length);
	bool get_reply_header(char* &buffer, int &length);
	bool get_reply_body(char* &buffer, int &length);
	bool get_reply_trailer(char* &buffer, int &length);
	
	// alternative reply
	bool get_reply();
	bool get_reply_body(int &fd);

	// parse reply
	MIME* media();
	int length(void);
	int errorcode(void);

	// Read .mime.types file:
	bool read_mime_types(char* filename);
      protected:
	dictionary<MIME> mime_dict;	// to map suffix on MIME type
      private:
	char* buffer_;
	MIME* defaultmime_;
	char* name_;
	int length_;
	url* url_;
	FILE* file_;
	bool got_reply_;
};

#endif
