// url.c
//
// simple implementation for a url class
// based on Jacco's url class:
// Experimental class for url handling/parsing.
// Conforms to Copliens cannonical class form...
//
// October 1995
// Bastiaan Sch\"onhage


#ifndef _hush_url_h_
#define _hush_url_h_

#include <hush/export.h>


class HUSH_API url {
  public:
    url();
    url(const char* const);  // e.g. url("http://www.cs.vu.nl/~dejavu/")
    url(const url&);
    virtual ~url();
    url& operator=(const url&);
    virtual operator char*() const;

    void init(const char* const);
    const char* expand(const char *string);	// expand string using base
    
    virtual const char* protocol() const;	// e.g. http
    virtual const char* host() const;		// e.g. www.cs.vu.nl
    virtual const char* locator() const;	// e.g. ~dejavu/
    virtual int port() const;			// e.g. 80 (default)
  protected:
    char *protocol_, *host_, *locator_;
    int port_;
    char* s_;		// "string" version of url
    char* es_;		// expanded string
    void makestring();
  private:
    void clean_up();
};

#include<iostream.h>
inline ostream& operator<<(ostream& os, const url& u) { return os << (char*) u; }

#endif 

