////////////////////////////////////////////////////////////////////////
//                                                                    //
// hush.h                                                             //
//                                                                    //
// to make the simulation programs compatible                         //
//                                                                    //
// (c) 1995 D. Bolier, A. Eliens                                      //
//                                                                    //
////////////////////////////////////////////////////////////////////////

#ifndef SIM__HUSH_H
#define SIM__HUSH_H

#include <hush/export.h>

#ifdef HUSH  // HUSH definitions

#ifdef NOSIM
#undef NOSIM
#endif

#include <hush/hush.h>
#include <hush/widgets.h>

#else // ASCII definitions, functionality = 0

#include <hush/sim/defs.h>
#include <hush/sim/event.h>

class HUSH_API item {
public:
};

class HUSH_API widget
{
public :
  widget() { }

  inline virtual char* name() const { return "anonymous"; }

  widget(const char* path, const char* opts = 0)
  {
	if (path && opts); //Wall
    //p = p;
  }

  widget(const widget* w, const char* p)
  {
    //w = w; p = p;
  }

  widget* pack(const widget* w, const char* opt = "")
  {
    return (widget*) w;
  }

  widget* pack(const char* opt="") { return this; }

  void destroy()
    {}
};

class HUSH_API canvas : public widget {
public:
canvas() { }
canvas(const char* path, const char* opts = "") : widget(path,opts) {
	if (path && opts); //Wall
	}
canvas(const widget* w, const char* p, const char* opts="") {
	if (w && p && opts); //Wall
}

};

class HUSH_API kit
{
public :
  kit()
    {}

  widget* pack(const widget* w, const char* options = "")
  {
    options = options;
    return (widget*) w;
  }

  widget* pack(const char*)		// bas
  {					// bas
    return (widget*) 0;			// bas
  }					// bas

  void update()
    {}
};

inline kit* thekit() { return new kit; }


class HUSH_API toplevel : public widget
{
public :
  toplevel(const char* p, const char* options = "") : widget(p)
  {
    options = options;
  }

  toplevel(const widget* w, const char* p, const char* options = "") 
						: widget(w,p)
  {
    options = options;
  }
};


class HUSH_API session
{
public :
  session(int _argc,char** _argv,char* _name = NULL)
  {
    tk = new kit();
    name = _name;
  }

  virtual void prelude() { }

  virtual void depends(const char*) { }		// bas

  static void statistics() { }			// bas

  virtual int main( ) { return 0; }    // used to have args: kit*, int, char**

  int run()
  {
    return main();
  }

protected :
  kit* tk;
  char* name;
};

// bastiaan added a class handler to handle events
class HUSH_API handler
{
public:
  handler() {}

  event* dispatch(event* ev) {
	  _ev = ev;
	  int result = this->operator()();
	  if (result != OK) return 0;
	  else return ev;
  }

  virtual int operator()() {
	  return OK;
  }
	  
private:
  event* _ev;
};
// end of handler class, bastiaan

#endif

#endif
