//// The TYPE 'dispatch logic' for inner and outer contexts

#ifndef ANCESTOR
#define ANCESTOR handler
#endif

TYPE* TYPE::_default = 0;

int TYPE::invariant() const { // _body is private, _context() is from TYPE
	return handler::invariant() &&
	(_body() != this) && !(_body() && _context());
	}

//// To check whether there is an inner or outer context

TYPE* TYPE::_body() const { return (TYPE*) _bdy; }  // private

int TYPE::_exists() const { return _this() != this; }

TYPE* TYPE::_this() const {        // private
	if (_body()) return  _body();
	else if (_context()) return  _context();
	else return (TYPE*) this;
	}


// General self dispatch -- see TYPEs/hush/dispatch.i

//int TYPE::exists() const { return self() != this; }


TYPE* TYPE::_context() const { return (TYPE*) ANCESTOR::_context(); }
TYPE* TYPE::_self() const { return (TYPE*) ANCESTOR::_self(); }

TYPE* TYPE::self() const {  return (TYPE*) ANCESTOR::self(); }
