#ifndef _GARBAGE_H
#define _GARBAGE_H

//#include <iostream.h>


#include <hush/export.h>
#include <hush/sys/cell.h>


class HUSH_API garbage_type {
public:
  garbage_type(); //{ created++;}
  virtual ~garbage_type(); //{ deleted++;}
  static int created;
  static int deleted;
};

template<class T>
class dvgarbage : public garbage_type {
  int _check;

public:
  dvgarbage( int i = 0 ) { _check = i; _body = 0; }
  ~dvgarbage() { 
    dvcell* tmp = _body;
    while (_body) {
      T* p = (T*) _body->el;
      if (p) delete p;
      _body = _body->next;
    }
    if (tmp) delete tmp;
  }

  void _register(const T* e) const { 
    if (e && _check && _body && _body->contains((void*)e)) 
	;
    else if (e)
	((dvgarbage<T>*)this)->_body = new dvcell((void*)e, _body);
  }

  dvgarbage<T>* operator ->() { return this; }

private:
   dvcell* _body;
};


#ifndef garbage
#define garbage dvgarbage
#endif

#endif
