//// Hush garbage --

#ifndef _HUSH_GARBAGE
#define _HUSH_GARBAGE

#include <hush/flags.h>
#include <hush/hush.h>
#include <hush/iter.h>
#include <hush/term.h>

#include <hush/api/srv.h>
#include <hush/api/clt.h>

#include <hush/api/vm.h>

#include <hush/sys/cell.h>

class dvstring;
class dvlist_type;
class garbage_type;
class dictionary_type;


class hush_garbage {
public:
    hush_garbage();
    ~hush_garbage();
    void _register( const handler* h);
    void _register( const term* t);
    void _register( const char* a);
    void _register( const dvcell* c);
    void _register( const dvstring* );
#ifndef NOLIST
    void _register( const dvlist_type* l);
#endif
    void _register( const dictionary_type* d);
    void _register( const iter_type* i);
    void _register( const garbage_type* z);
    void _register( const hush_garbage* r);
    void _register( const dvbinding* b);
    void _register( const srv_type* i);
    void _register( const clt_type* i);
    void _register( const vm_type* i);

private:
void *vmgarb, *garb, *agarb, *tgarb, *hgarb, *cgarb, *sgarb,
*lgarb, *igarb, *dgarb, *rgarb, *bgarb, *clgarb, *srgarb;
};

#endif
