#ifndef IO_H
#define IO_H

#include <hush/export.h>
#include <hush/handler.h>
#include <iostream.h>

class HUSH_API IO : public handler {
public:
IO();
virtual void print(ostream& (*)(ostream&));
virtual void print(const char*);
virtual void print(int i);
virtual void print(void*);

virtual void flush();

int ok() { return !silent; }

void (*_print)(const char*);

static int silent;
static IO* _default;

static int initialized;
static int initialize();
}; //dummy

inline IO& operator<<(IO& x, ostream& (*f)(ostream&)) { if (x.ok()) x.print(f); return x; }
inline IO& operator<<(IO& x, const char* s) { if (x.ok()) x.print(s); return x; }
inline IO& operator<<(IO& x, int n) { if (x.ok()) x.print(n); return x; }
inline IO& operator<<(IO& x, void* p) { if (x.ok()) x.print(p); return x; }
#endif
