// requires TYPE -- deals with static members

#include <hush/session.h>
#include <hush/dictionary.h>
#include <hush/assert.h>

#ifndef TABLE
#define TABLE table
#endif

#ifndef DESTROY
#define DESTROY destroy
#endif

#ifndef POINTER
#define POINTER TYPE*
#endif

#ifndef DICTIONARY
#define DICTIONARY (*((dictionary<TYPE>*)TYPE::TABLE))
#endif

#ifdef WIN32
#pragma data_seg(".SHARDAT")
#endif

int TYPE::created = 0;
int TYPE::deleted = 0;

void* TYPE::TABLE = 0;

#ifdef WIN32
#pragma data_seg()
#endif
 
void TYPE::declare( const char* s, void* h, int flag ) {
	require(s);
        if (!TYPE::TABLE) {
		TYPE::TABLE = (dictionary<TYPE>*) new dictionary<TYPE>;
		session* x = session::_default;
		if (x) x->_register( (dictionary<void>*) TYPE::TABLE );
		}
        DICTIONARY[s] = (TYPE*) h;
	if (flag) DICTIONARY._register((TYPE*)h);
        }
 
POINTER TYPE::lookup( const char* s ) {
        if (!TYPE::TABLE) return 0;
	else if (!s) return 0;
        else return (POINTER) DICTIONARY[s];
        }
 
void TYPE::DESTROY( ) {
        if (TYPE::TABLE) delete (dictionary<TYPE>*) TYPE::TABLE;
	TYPE::TABLE = 0;
        }
