// See man:iter(4)

#ifndef T_ITER_H
#define T_ITER_H

class handler;

#include <hush/export.h>

#undef declare

class HUSH_API iter_type {
public:
iter_type(); // { created++; }
virtual ~iter_type(); // { deleted++; }

//#pragma data_seg(".SHARDAT")
static int created;
static int deleted;
//#pragma data_seg()

static void* table;
static void declare(const char*, void*, int flag = 0);
static iter_type* lookup(const char*);
static void destroy();
};

template<class T>
class iter : public iter_type {
public:
iter() { _p = 0; _refs = 0; }
iter(const iter<T>* p_) { _p = (iter<T>*) p_; _refs = 0; }
iter(const iter<T>& i_) { _p = i_._p; _p->_refs++; }
iter<T>& operator=(const iter<T>* it) {
	_p = (iter<T>*) it;
	return *this;
	}
iter<T>& operator=(const iter<T>& i) { 
	if (_p) { if (_p->_refs==0) delete _p; else _p->_refs--; } 
	_p = i._p; _p->_refs++;
	return *this;
	}
virtual ~iter() { _p = 0; }
int operator==(const iter<T>&) const { return 0; }
virtual T* operator()()  { return _p ? (*_p)() : 0; }
private:
iter<T>* _p;
int _refs;

public:
static void declare(const char* s, void* h, int flag = 0) {
	iter_type::declare(s,h,flag);
	}

static iter<T>* lookup(const char* s) {
	return (iter<T>*) iter_type::lookup(s); 
	}

};


#endif
