#ifndef hush_vm_h
#define hush_vm_h

#include <hush/api/vm.h>
#include <hush/kit.h>

#include <stdlib.h>
#include <stdio.h>

#include <hush/event.h>


template<class T>
class vm : public vm_type {
public:
vm(int p = 0, kit* q = 0) { init(p,q); }
vm(event* e) {
	int p = 0;
	char* id = e->option("ref");
	//cerr << "vm: " << id << endl;
	if (id) {
		p = atoi(id);
		}
	kit* k = e?e->thekit():0;
	init(p,k);
        }

void init(int p = 0, kit* q = 0) {
        _pointer = p;
        _self = (T*) _pointer;
	_kit = q;
        }

virtual event* dispatch(event* e) {
	char buf[512]; 
	sprintf(buf,":handler(%d):dispatch(event(%d))",
			(int)_pointer,(int)e);
	eval(buf);
	return e;
	}

int source(const char* cmd) { return _kit?_kit->source(cmd):0; }
long eval(const char* cmd) { return _kit?_kit->eval(cmd):0; }
char* result(long id) { return _kit?_kit->result(id):0; }
char* evaluate(const char* cmd) { return _kit?_kit->evaluate(cmd):0; }

virtual int call(const char* cmd) { 
	char buf[512]; int n = 0;
	sprintf(buf,"X:event(%d):%s(X)",(int)_pointer,cmd);
	char* res = evaluate(buf);
	sscanf(res,"%d",&n);
	return n;
	}

virtual inline T* operator->() { return self(); }
virtual inline T* self() { return _self; }

private:
T* _self;
long _pointer;
public:
kit* _kit;

public:
static void declare(const char* s, void* h, int flag = 0) {
        vm_type::declare(s,h,flag);
        }

static vm<T>* lookup(const char* s) {
        return (vm<T>*) vm_type::lookup(s); 
        }

};

#endif
