#ifndef AWSBALLOON_H
#define AWSBALLOON_H

#include <hush/string.h>
#include <hush/widgets/toplevel.h>
#include <hush/widgets/label.h>
#include <hush/widgets/message.h>
#include <hush/widgets/frame.h>

/*
 * The aws_balloon widget is significantly different from most other 
 * (hush) widgets, as are most compound widgets.
 */
 
class aws_balloon : public toplevel {
public:
	aws_balloon();
	aws_balloon(char* p, char* options = "");
	aws_balloon(widget* w, char* p, char* options = "");

	~aws_balloon();

	label	*subLabel(const char *opt = NULL) const;
	frame	*subFrame(const char *opt = NULL) const;

	void	statusBar(label *statusLabel);
	void	statusBar(message *statusMessage);

	// 'popup' may be "" if you only want to set a statusmessage
	void	bind(widget *w, const char *popup, const char *msg = "");
private:
	void	initialize(void);
	int	operator()();

	void	withdraw(void);
	void	deiconify(void);
	void	overrideredirect(void);

	void	popup(void);
	void	popdown(void);

	frame	*msgFrame;
	label	*msgLabel;
	label	*statusLabel;
	message	*statusMessage;

	string	after_id;
};

#endif // AWSBALLOON_H

