#ifndef AWSCOMBOBOX_H
#define AWSCOMBOBOX_H

#include <hush/string.h>
#include <hush/widgets/frame.h>
#include <hush/widgets/entry.h>
#include <hush/widgets/button.h>
#include <hush/widgets/toplevel.h>
#include <hush/widgets/listbox.h>

class aws_combobox : public frame {
public:
	aws_combobox();
	aws_combobox(char* p, char * options = "");
	aws_combobox(widget* w, char* p, char * options = "");

	frame		*subFrame(const char *opt = NULL) const;
	entry		*subEntry(const char *opt = NULL) const;
	button		*subButton(const char *opt = NULL) const;
	toplevel 	*subToplevel(const char *opt = NULL) const;
	listbox		*subListbox(const char *opt = NULL) const;
	
	// entry 
	void		insert(const char *txt);
	void		del(void);

	// listbox
	void		insert(int index, const char *txt);
	void		del(int entry);
	void		del(int begin, int end);

	// retrieval of selections/entries
	char		*get(void);
	int		curselection(void);
	char		*selection(int index = -1);
	int		size(void);

	// bindings
	int		bind(handler *h, const char *arg);
	
	int		operator()();

private:

	void		initialize(const char *);

	void		buildPulldown(void);
	void		hidePulldown(void);
	void		showPulldown(void);

	void		passEvent(const char *ev);
	void		handleEvent(const string &ev);
	frame		*cbFrame;
	entry		*cbEntry;
	button		*cbButton;
	toplevel	*cbToplevel;
	listbox		*cbListbox;

	string		options;
	string		eventArg;

	// stored grab information
	string		currentGrab;
	string		statusGrab;

	enum		{ opened, closed } 	state;

	int		cbId;
	bool		handlerInstalled;
static	string		arrowBitmap;
static	int		cbCount;
};

#endif // AWSCOMBOBOX_H
