#ifndef AWSDIALOG_H
#define AWSDIALOG_H

#include <hush/widgets/toplevel.h>
#include <hush/widgets/frame.h>
#include <hush/widgets/label.h>


class aws_dialog : public toplevel {
public:
	aws_dialog();
	aws_dialog(char* p, char* options = "");
	aws_dialog(widget* w, char* p, char* options = "");

	~aws_dialog();

	void	text(const char *txt);
	void	image(const char *img);
	
	void	show(void);
	char	*getChoice(bool doGrab = true);

	// handler for buttons, either intern or extern
	button	*addButton(const char *txt, const char *arg = "", 
			   const char *opts = "");
	button	*addButton(handler *h, const char *txt, const char *arg = "",
			   const char *opts = "");

	// Access to internals
	label	*subMessageLabel(const char *opt = NULL) const;
	label	*subImageLabel(const char *opt = NULL) const;
	frame	*subWidgetFrame(const char *opt = NULL) const;
	// make other widgets accessible?
	
private:
	void	initialize(void);
	int	operator()();

	frame	*dlgTopFrame, *dlgTopRightFrame, *dlgMessageFrame, 
		*dlgWidgetFrame, *dlgButtonFrame;
	label	*dlgImageLabel, *dlgMessageLabel;

	bool	labelConfigured;
	int	buttonCount;

	// for storing previous grab state
	string	currentGrab;
	string  statusGrab;

	string	buttonResult;
	char	dialogVar[32];
static	int	dialogCount;
};

class	aws_YesNoDialog: public aws_dialog
{
public:
	aws_YesNoDialog() 
	{
		initialize();
	}
	aws_YesNoDialog(char* p, char* options = ""): aws_dialog(p, options)
	{
		initialize();
	}
	aws_YesNoDialog(widget* w, char* p, char* options = ""): 
		       aws_dialog(w, p, options)
	{
		initialize();
	}
	~aws_YesNoDialog() {}

private:
	void	initialize(void)
	{
		addButton(this, "Yes");
		addButton(this, "No");
	}
};

#endif // AWSDIALOG_H
