#ifndef _HUSH_BROWSER_H_
#define _HUSH_BROWSER_H_

#include <widgets/export.h>

#include <hush/widgets/frame.h>
#include <hush/net/client/MIME.h>

class WIDGETS_API browser : public frame {
public:
  char* type() const;

  browser();
   
  browser(const char* p, const char* opts = "", browser* = 0);
  browser(const widget* w, const char* p, const char* ="", browser* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~browser();

  
  virtual void plugin(MIME* type, handler* v); // AE
  virtual void plugin(char* type, handler* v); // AE

  virtual void home(const char* url);

  virtual void load(const char* url);

  virtual void resize(int x, int y ); // promotes to web
  virtual void geometry(int x,int y); // ae - an alias

  virtual handler* urlhandler();

  
  

public: 
	browser* self() const;

	browser* _body() const; // virtual
	browser* _context() const;
	browser* _self() const;
private: 
	browser* _bdy;
	int _exists() const;
	browser* _this() const; // non-virtual

public: // factory

static browser* _default;
static browser* get_default();
static void set_default(browser*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static browser* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
