#ifndef BUTTON_H
#define BUTTON_H

#include <hush/widget.h>
#include <widgets/export.h>

class WIDGETS_API button : public widget {
public:

  char* type() const; // const
  
  button();
  
  button(const char* p, const char* opts = "", button* = 0);
  button(const widget* w, const char* p, const char* ="", button* = 0);
  
  virtual widget* _create(const char* p, const char* opts = "",
  				widget* = 0);
  virtual widget* _create(const widget* w, const char* p,
  				const char* opts = "", widget* = 0);
  
  virtual ~button();
  
  virtual void text(const char* s);
  virtual void bitmap(const char* s);
  virtual void image(const char* s);
  
  virtual void state(const char *s);
  
  virtual void flash();
  
  virtual char* invoke();

protected:
  virtual void install(dvbinding* ac, const char* args = ""); 

//// The dispatch logic -- redoing the obvious

public: 
	button* self() const;

	button* _body() const; // virtual
	button* _self() const;
	button* _context() const;
private: 
	button* _bdy;   // to actual implementation
	int _exists() const;
	button* _this() const; // non-virtual

public: // factory

static button* _default;
static button* get_default();
static void set_default(button*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static button* lookup(const char*);

public: 
static int created;
static int deleted;
};

#include <hush/widgets/radio.h>
#include <hush/widgets/check.h>
#endif
