#ifndef _srv_canvas_h
#define _srv_canvas_h
 
#include <widgets/canvas.h>
#include <hush/api/srv/widget.h>
#include <hush/api/srv/item.h>

class canvas_srv : public widget_srv, _crob(widgets,canvas)  {
public:
    canvas_srv(canvas* c) : widget_srv(c) { }

    canvas_srv(const char* p, const char* opts) {
	widget* bdy = new canvas(p,opts);
	session::_default->_register(bdy);
	set_body(bdy);
	}

    canvas_srv(hush::widget* w ,const char* p, const char* opts = "") {
	widget_srv* c = (widget_srv*) w ->_deref();
	widget* bdy = new canvas(c->_body(),p,opts);
	session::_default->_register(bdy);
	set_body(bdy);
	}

    //virtual hush::event* dispatch(hush::event* e, ENV); // AE

    virtual widgets::canvas* create(hush::widget* w ,const char* p, ENV) {
	return new canvas_srv(w,p);
	//session::_default->_register(bdy);
	//return bdy;
	}

    virtual hush::item* circle( long x, long y, long r, const char* opts, ENV) {
    //virtual hush::item* circle( CORBA::Long x, CORBA::Long y, CORBA::Long r, const char* opts, ENV) {
	cerr << "CIRCLE: " << _body()->path() << " " << _body() << endl;
	item* it = _body()->circle((int)x, (int) y, (int) r, opts );
	hush::item* rit = new item_srv(it);
	//hush::item::_duplicate(rit);
	rit->_duplicate();
	return rit;
	}

protected:
    canvas* _body() { return (canvas*) widget_srv::_body(); }
};


/*
#include <dv/clt/event.h>

#ifndef INLINE
#define INLINE inline
#endif

INLINE
hush::event* canvas_srv::dispatch(hush::event* e, ENV) {
	cerr << "CANVAS: dispatch ";
	event* cl = new event_clt(e);
	cerr << cl->type() << " " << cl->x() << " " << cl->y();
	cerr << " for " << _body()->path() << " " << _body() << endl;
	event* res  = _body()->dispatch( cl );
        hush::event* x = new event_srv(res);
	//hush::event::_duplicate(x);
	x->_duplicate();
	return x;
	}

#undef INLINE
*/

#endif
