#ifndef _widgets_srv_dot_h
#define _widgets_srv_dot_h

#include <hush/api/srv/dot.h>

#include <hush/widgets.h>
#include <widgets/corba.h>
#include <hush/widgets/srv/widgets.h>
#include <hush/widgets/srv/factory.h>

class widgets_dot_srv : public virtual hush_dot_srv, _crob(widgets,dot) {
public:

    virtual widgets::message* message(const char* name, ENV) {
	::message* m = message::lookup(name);
	if (!m) m = new ::message(name,0); // AE -- Bastiaan !!
	widgets::message* x = new message_srv(m);
	cerr << "Exporting message " << m->path() << endl;
	//widgets::message::_duplicate(x);
	x->_duplicate();
	return x;
	}

    virtual widgets::canvas* canvas(const char* name, ENV) {
	::canvas* c = canvas::lookup(name);
	if (!c) c = new ::canvas(name,0);
	widgets::canvas* x = new canvas_srv(c);
	//widgets::canvas::_duplicate(x);
	x->_duplicate();
	return x;
	}

    virtual widgets::factory* widgets(const char* name, ENV) {
        widgets::factory* x = new widgets_factory_srv();
        //widgets::factory::_duplicate(x);
	x->_duplicate();
        return x;
    }

};

//DEF_TIE_hush_dot(dot)
//DEF_TIE_widgets_dot(dot)

#endif
