//#include <iostream.h>

#ifndef CREATE
#define CREATE ((!ctx || ctx == this ) && opts )
#endif

#ifndef ANCESTOR
#define ANCESTOR widget
#endif

#ifndef DEFAULT
#define DEFAULT _bdy = 0;
#endif

#ifndef DEFAULTX
#define DEFAULTX _bdy = 0; if (ctx == this) cerr << "THIS" << endl;
#endif

#ifndef OPTS
#define OPTS opts
#endif

#ifndef CTX
#define CTX ctx
#endif

#ifndef CONSTRUCTOR
#define CONSTRUCTOR
#endif

#ifndef DESTRUCTOR
#define DESTRUCTOR
#endif


#ifndef BODY
#define BODY _bdy
#endif

#ifndef CONTEXT
#define CONTEXT TYPE
#endif

#ifndef THIS
#define THIS _this()
#endif

TYPE* TYPE::_default = 0;
void TYPE::set_default(TYPE* w) { _default = w; }
TYPE* TYPE::get_default() { return _default; }

int TYPE::created = 0;
int TYPE::deleted = 0;

//// For dispatching

#include "table.i"

int TYPE::_exists() const { return _this() != this; }

TYPE* TYPE::_this() const { 
	TYPE* result = (TYPE*) this;
	if (_context()) result = _context();
	else if (_body()) result = _body();
	else result = self();
	return result;
	}

TYPE* TYPE::_body() const { return BODY; } 
TYPE* TYPE::_context() const { return (TYPE*) handler::_context(); }
TYPE* TYPE::_self() const { return (TYPE*) handler::_self(); }

TYPE* TYPE::self() const { return (TYPE*) widget::self(); } 

//// Constructors

TYPE::TYPE() : ANCESTOR() {
	TYPE::created++;
	DEFAULT; 
	}


TYPE::TYPE(const char* p, const char* opts, CONTEXT* ctx ) 
				       : ANCESTOR(p,OPTS,CTX) { 
	TYPE::created++;
	DEFAULT;
	if ( CREATE ) {
		_debug(type(),p);
		TYPE* h = TYPE::_default;
		if (!h) 
			_error("WIDGET","does not exist");
		else {
			_bdy = (TYPE*) h->_create(p,opts,this);
			_bdy->_reparent( this );
			_register(_bdy);
			_debug(_bdy->info(), path() );
			}
		}
	else if (!opts || ctx ) {
		_bdy = ctx; // is this necessary
		//_reparent(ctx);
	} else {
		_debug(type(),"exists");
		}
	CONSTRUCTOR;
	}

TYPE::TYPE(const widget* w, const char* p, const char* opts,
			CONTEXT* ctx) : ANCESTOR(w,p,OPTS,CTX) {
	TYPE::created++;
	DEFAULT;
	if ( CREATE ) {
		_debug(type(),p);
		TYPE* h = TYPE::_default;
		if (!h) 
			_error("WIDGET","does not exist");
		else {
			_bdy = (TYPE*) h->_create(w,p,opts,this);
			_bdy->_reparent( this );
			_debug(_bdy->info(), path() );
			}
		}
	else if (!opts || ctx ) {
		_bdy = ctx;
		//_reparent(ctx);
	} else { 
		_debug(type(),"exists");
		}

	CONSTRUCTOR;
	}

TYPE::~TYPE() { 
	TYPE::deleted++;
	DESTRUCTOR;
	}

widget* TYPE::_create(const char* p, const char* opts, widget* x) {
	if ( _this() != this ) 
		return _this()->_create(p,opts,x);
	else
		return new TYPE(p,opts,(TYPE*)x);
	}


widget* TYPE::_create(const widget* w, const char* p, const char* opts,
							widget* x) {
	if ( _this() != this ) 
		return _this()->_create(w,p,opts,x);
	else
		return new TYPE(w,p,opts,(TYPE*)x);
	}
