#ifndef CHOOSER_H
#define CHOOSER_H

#include <widgets/export.h>
#include <hush/widgets/frame.h>

class WIDGETS_API filechooser : public frame {
public:

  char* type() const; // const
  
  filechooser();
  
  filechooser(const char* p, const char* opts = "", filechooser* = 0);
  filechooser(const widget* w, const char* p, const char* ="", filechooser* = 0);
  
  virtual widget* _create(const char* p, const char* opts = "",
  				widget* = 0);
  virtual widget* _create(const widget* w, const char* p,
  				const char* opts = "", widget* = 0);
  
  virtual ~filechooser();
  
  virtual void mask(const char *m);   // set filename mask (default "*")
  virtual const char* mask() const;   // get    ,,      ,,
  virtual int dirpath(const char* path); // set current dir path
  virtual const char* dirpath() const ;  // get current dir
  virtual void rescan();              // rescan & display current dir
  virtual const char* get();          // get (and wait for) filename


protected:
  virtual void install(dvbinding* ac, const char* args = ""); 

//// The dispatch logic -- redoing the obvious

public: 
	filechooser* self() const;

	filechooser* _body() const; // virtual
	filechooser* _self() const;
	filechooser* _context() const;
private: 
	filechooser* _bdy;   // to actual implementation
	int _exists() const;
	filechooser* _this() const; // non-virtual

public: // factory

static filechooser* _default;
static filechooser* get_default();
static void set_default(filechooser*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static filechooser* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
