#ifndef _hush_widgets_glwin_h
#define _hush_widgets_glwin_h

#include <hush/widget.h>
#include <widgets/export.h>

class WIDGETS_API glwin : public widget {
public:

char* type() const ;

glwin();

glwin(const char* p, const char* options = "", glwin* = 0);
glwin(const widget* w, const char* p, const char* options = "", glwin* = 0);

virtual widget* _create(const char* p, const char* opts = "",
                                widget* = 0);
virtual widget* _create(const widget* w, const char* p,
                                const char* opts = "", widget* = 0);
virtual ~glwin();


virtual void draw();
virtual void redraw();

virtual void link(); 
virtual void swap(); 

virtual int file(const char* name = 0);

virtual void loop(const char* name = 0);
virtual void restore();
virtual void pan(float dx, float dy = 0 , float dz = 0);
virtual void zoom( int i = 1 );

protected:
void install(dvbinding* ac, const char* args);

public: 
        glwin* self() const;

        glwin* _body() const; // virtual
        glwin* _self() const;
        glwin* _context() const;
private: 
        glwin* _bdy;   // to actual implementation
        int _exists() const;
        glwin* _this() const; // non-virtual

public: // factory

static glwin* _default;
static glwin* get_default();
static void set_default(glwin*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static glwin* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
