#ifndef _hush_widgets_glxwin_h
#define _hush_widgets_glxwin_h

#include <hush/widget.h>
#include <widgets/export.h>

class WIDGETS_API glxwin : public widget {
public:

char* type() const ;

glxwin();

glxwin(const char* p, const char* options = "", glxwin* = 0);
glxwin(const widget* w, const char* p, const char* options = "", glxwin* = 0);

virtual widget* _create(const char* p, const char* opts = "",
                                widget* = 0);
virtual widget* _create(const widget* w, const char* p,
                                const char* opts = "", widget* = 0);
virtual ~glxwin();

void configure(const char*);
void geometry(int,int);

virtual void draw();
virtual void redraw();

virtual void link(); 
virtual void swap(); 

protected:
void install(dvbinding* ac, const char* args);

//// The dispatch logic -- redoing the obvious

public: 
        glxwin* self() const;

        glxwin* _body() const; // virtual
        glxwin* _self() const;
        glxwin* _context() const;
private: 
        glxwin* _bdy;   // to actual implementation
        int _exists() const;
        glxwin* _this() const; // non-virtual

public: // factory

static glxwin* _default;
static glxwin* get_default();
static void set_default(glxwin*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static glxwin* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
