#ifndef HUSH_LABEL_H
#define HUSH_LABEL_H

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API label : public widget {
public:
  char* type() const;
  
  
  label();
   
  label(const char* p, const char* opts = "", label* = 0);
  label(const widget* w, const char* p, const char* ="", label* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~label();
  
  virtual void text(const char* s);
  virtual void text(int value);
  virtual void text(double value, int precision=6);

  virtual void bitmap( const char* s );
  virtual void image( const char* s );

public: 
	label* self() const;

	label* _body() const; // virtual
	label* _context() const;
	label* _self() const;
private: 
	label* _bdy;
	int _exists() const;
	label* _this() const; // non-virtual

public: // factory

static label* _default;
static label* get_default();
static void set_default(label*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static label* lookup(const char*);

public: 
static int created;
static int deleted;
};
#endif
