#ifndef MENUBAR_H
#define MENUBAR_H

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API menubar : public widget {
public:

  char* type() const ;

  menubar();
   
  menubar(const char* p, const char* opts = "", menubar* = 0);
  menubar(const widget* w, const char* p, const char* ="", menubar* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~menubar();
  
  virtual widget* append(const char* w, const char* options = "-side left");
  virtual widget* append(widget* w, const char* options = "-side left");
  
private:
  void init(const char* options);

public: 
	menubar* self() const;

	menubar* _body() const; // virtual
	menubar* _context() const;
	menubar* _self() const;
private: 
	menubar* _bdy;
	int _exists() const;
	menubar* _this() const; // non-virtual

public: // factory

static menubar* _default;
static menubar* get_default();
static void set_default(menubar*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static menubar* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
