#ifndef RADIOBUTTON_H
#define RADIOBUTTON_H

#include <widgets/export.h>

#include <widgets/button.h>

class WIDGETS_API radiobutton : public button {
public:

  char* type() const;
  

  radiobutton();
   
  radiobutton(const char* p, const char* opts = "", radiobutton* = 0);
  radiobutton(const widget* w, const char* p, const char* ="", radiobutton* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~radiobutton();
  
  virtual void variable(const char* name);
  
  virtual char* value() const;
  
  virtual void toggle();
  
  virtual void select();
  virtual void deselect();

//private: char* _name; void init(const char* options);


public: 
	radiobutton* self() const;

	radiobutton* _body() const; // virtual
	radiobutton* _context() const;
	radiobutton* _self() const;
private: 
	radiobutton* _bdy;
	int _exists() const;
	radiobutton* _this() const; // non-virtual

public: // factory

static radiobutton* _default;
static radiobutton* get_default();
static void set_default(radiobutton*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static radiobutton* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
