/** <title>Class definition of the filechooser</title>
 <h2>Class definition of the filechooser</h2>
 <p>Author: martijn, bastiaan, jrvosse
<i>Warning: This filechooser may change your applications current working 
directory!</i>
**/
// <ignore>

#ifndef HUSH_FILECHOOSER_H
#define HUSH_FILECHOOSER_H

#include <hush/export.h>

// </ignore>

#include <hush/bool.h> 
#include <hush/widgets/widgets.h> // We need a lot of widgets 
#include <hush/widgets/chooser.h>

class WIDGETS_API tk_filechooser: public filechooser {
  public:
    // Typical hush stuff:
    char* type() const { return "tk_filechooser"; }

    char* category() const; //AE

    tk_filechooser(const char *p, const char* options="", 
					filechooser* = 0);  
    tk_filechooser(const widget* w, const char *p, 
		const char* options="", filechooser* = 0);
    tk_filechooser();             // make handler for tcl command "tk_filechooser"

    // AE

    widget* _create(const char*, const char* = "", widget* = 0);
    widget* _create(const widget*, const char*, const char* = "", widget* = 0);

    virtual ~tk_filechooser();            // destruct C++ object (not window!)
    virtual int operator()();           // handle events
    //event* dispatch(event* e);

    // Typical tk_filechooser stuff:
    virtual void mask(const char *m);   // set filename mask (default "*")
    virtual const char* mask() const;   // get    ,,      ,,
    virtual int dirpath(const char* path); // set current dir path
    virtual const char* dirpath() const ;  // get current dir
    virtual void rescan();              // rescan & display current dir
    virtual const char* get();          // get (and wait for) filename

  protected:	// Derived classes can redefine these: 
    virtual widget* create(int argc, char* argv[]);     // create new widget
    virtual void build_gui(widget* top, const char* opts =""); // set up GUI
    virtual void bindings();                            // install bindings
    virtual void options(const char* opts);             // process options
    virtual int usage(const char* msg) const;           // print usage
    
  private:      // I hate to have this private stuff in my header files:

    void init(const char*);

    listbox *_listbox;
    button  *_okbutton,  *_cancelbutton;
    entry   *_fileentry, *_maskentry, *_pathentry;
    char    _filename[100], _pathname[100], _mask[100];
public:
static filechooser* _default;
static int initialized;
static int initialize();
};

//<ignore>
#endif
//</ignore>
