#ifndef TOPLEVEL_H
#define TOPLEVEL_H

#include <widgets/export.h>

#include <widgets/frame.h>

// (ae): Don't use toplevels unless STRICTLY neceesary!

class WIDGETS_API toplevel : public frame {
public:

  char* type() const ;
  
  toplevel();
   
  toplevel(const char* p, const char* opts = "", toplevel* = 0);
  toplevel(const widget* w, const char* p, const char* ="", toplevel* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~toplevel();
  
  virtual void position(int xcoord=300, int ycoord=300);
  virtual void resize(int width=100,  int height=100);
  
  virtual void transient(const char* w = ".");

protected:
//void init(const char*);

public: 
	toplevel* self() const;

	toplevel* _body() const; // virtual
	toplevel* _context() const;
	toplevel* _self() const;
private: 
	toplevel* _bdy;
	int _exists() const;
	toplevel* _this() const; // non-virtual

public: // factory

static toplevel* _default;
static toplevel* get_default();
static void set_default(toplevel*);

static void* table;
static void declare(const char*, void*, int flag = 0);
static toplevel* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
