// browser.h
//
// a sample browser that uses the web widget
//
// Bastiaan Sch\"onhage
// 1995, 1996

#ifndef BROWSER_H
#define BROWSER_H

#include <hush/export.h>

#include <hush/widgets/browser.h>
#include <hush/net/client/url.h>
#include <hush/widgets/web/web.h>
#include <hush/widgets/web/viewer.h>
#include <hush/widgets/frame.h>
#include <hush/widgets/entry.h>

class HUSH_API tk_browser : public browser
{
      public:
	//tk_browser(); // command interface
	//tk_browser( const char* p, const char* options="" );
	//tk_browser( const widget* w, const char* p, const char* options="" );
	//~tk_browser();
	 
char* category() const;

tk_browser();
tk_browser(const char* p, const char* options = "", browser* = 0);
tk_browser(const widget* w, const char* p, const char* options = "", browser* = 0)
;

widget* _create(const char*, const char* = "", widget* = 0);
widget* _create(const widget*, const char*, const char* = "", widget* = 0);

virtual ~tk_browser();



	void plugin(MIME* type, handler* v); //AE: was viewer
	void plugin(char* type, handler* v);

	int operator()();
	void home(const char* url);

	void load(const char* url);

	void resize(int x, int y ); // promotes to web
	void geometry(int x,int y); // ae - an alias

	handler* urlhandler();
      private:
	void create( int argc, char* argv[]);
	frame* _body;
      private:
	void init(const char* options);

	web* Www;
	url* Home;
	entry* EntryBox;
public:
static browser* _default;
static int initialized;
static int initialize();
};

inline void init_browser(kit* tk) {
	handler* h = new tk_browser();
	tk->bind("browser",h);
	tk->_register(h);
	}


#endif
