
// url_event.h
// a derived event class for specifying an urlevent
//
// november 1995
// Bastiaan Sch\"onhage

#ifndef URL_EVENT_H
#define URL_EVENT_H

#include <hush/export.h>

#include <hush/event.h>

const int URLEVENT = 333;

class HUSH_API url_event: public event
{       
  public:
        enum urltype {anchor, inline_url};

        url_event(const char* url, urltype type = anchor,
                  const char* desc="");
        virtual ~url_event();

        void url(const char* _url);     // set the url
        const char* url() const;        // get the url

        void urlclass(urltype type);    // set the url type
        urltype urlclass() const;       // get the url type

        void urlinfo(const char* desc); // set the user-info
        const char* urlinfo() const;    // get the user-info

        int eventclass() const {
                return URLEVENT;
        }

  private:
        char* Url;
        urltype UrlType;
        char* Info;
};

#endif
