#!/bin/sh
bin=`hush-bin`;
lib="."
omit=$bin/omit
quote=$bin/quote

plain=false
nolink=false
dolink=false
categories=

platform="`hush-platform`"
library=`hush-lib-platform`
echo=
out=
source=
includes=
defines=
undefines=
libraries=
modules=
args=
verbose=false

hush=false
dll=nil

prefix=
ext=


while [ $# -ge 1 ]; do case $1 in
	-) plain=true;;
	+*) categories="$categories `$omit 1 $1` ";;
	-v|-verbose) verbose="true";;
	-echo) echo=echo;;
	-hush) hush=hush;;
	-platform) platform=$2; shift;;
	-install) lib="\"`hush-lib-platform`\"";;
	install=*) lib="`$omit 8 $1`";;
	-link) dolink=true;;
	-c|\/c) nolink=true; source=$2; shift;;
	-G) dll=true;;
	-dll) dolink="true" ;;
	dll=*) dolink="true";dll="`$omit 4 $1`";;
	-o|\/out) out=$2; shift;;
	-I) includes="$includes $2 "; shift;;
	-D*) x="`$omit 2 $1`"; defines="$defines `$quote $x` ";;
	-U*) undefines="$undefines `$omit 2 $1` ";;
	-L) libraries="$libraries $2 "; shift;;
	-l*) modules="$modules `$omit 2 $1` ";;
	*) args="$args $1 ";;
	esac;
	shift;
done

if [ "$dolink" = "true" ]; then
	nolink="false";
	if [ "$dll" = "nil" ]; then dll=$out; fi;
fi;

CC=`hush-compiler`
LD=`hush-linker`

if [ "$dolink" = "false" ]; then

ccinc=
if [ "-" != "-$includes" ]; then
for x in $includes; do ccinc="$ccinc -I $x "; done 
fi;
if [ "$plain" = "false" ]; then ccinc="$ccinc -I $HUSH/include "; fi

ccdefs=
if [ "-" != "-$defines" ]; then
for x in $defines; do ccdefs="$ccdefs -D$x "; done 
fi;
if [ "$plain" = "false" ]; then ccdefs="-DPLATFORM=\"$platform\" "; fi

ccundefs=
if [ "-" != "-$undefines" ]; then
for x in $undefines; do ccdefs="$ccundefs -D$x "; done 
fi;
fi; ## dolink

cflags=`cflags $categories $platform`;
ldflags=`ldflags $categories $platform`;
 
if [ "$platform" = "win32" ]; then

ccargs=" /TP "

if [ "-" != "-$source" ]; then ccargs="$ccargs /c $source "; fi

ccargs="$ccargs $ccinc $ccdefs $ccundefs $args $cflags "

ldargs=

if [ "$nolink" = "false" ]; then

if [ "$dolink" != "true" ]; then ldargs=" $ldargs /link "; fi;
if [ "$plain" = "false" ]; then ldargs="$ldargs "; fi
if [ "-" != "-$out" ]; then ldargs="$ldargs /out:$out "; fi

if [ "-" != "-$libraries" ]; then
for x in $libraries; do ldargs="$ldargs  "; done 
fi;

if [ "$plain" = "false" ]; then ldargs="$ldargs $library/hush.lib "; fi

if [ "-" != "-$modules" ]; then
for x in $modules; do ldargs="$ldargs $x "; done 
fi;
if [ "$dolink" = "true" ]; then ldargs="$ldargs $args"; fi;
ldargs="$ldargs $ldflags ";
fi; ## nolink

if [ "$dolink" != "true" ]; then
if [ "true" = "$verbose" ]; then echo $CC $ccargs $ldargs; fi
$echo $CC $ccargs $ldargs;
if [ "$lib" != "." -a "$nolink" = "false" ]; then
         $echo cp $out $out.exe
	 echo cp $out.exe $lib;
	 $echo cp $out.exe $lib;
	 fi;
else
if [ "$dll" != "nil" ]; then 
	ldargs="$ldargs /dll /incremental:no /machine:I386 ";
	ldargs="$ldargs /out:$lib/$dll.dll /implib:$lib/$dll.lib /pdb:$lib/$dll.pdb ";
	##ldargs="$ldargs -MD -LD -Fe$dll.dll "
fi;
if [ "true" = "$verbose" ]; then echo $LD $ldargs; fi
##LD="$CC"
$echo $LD $ldargs;
fi;

else ## unix/solaris

ccargs=

if [ "-" != "-$source" ]; then ccargs="$ccargs -c $source "; fi

ccargs="$ccargs $ccinc $ccdefs $ccundefs $args $cflags  "

ldargs=

if [ "$nolink" = "false" ]; then
if [ "$plain" = "false" ]; then ldargs="$ldargs -L $lib "; fi
if [ "-" != "-$out" ]; then ldargs="$ldargs -o $out "; fi

if [ "-" != "-$libraries" ]; then
for x in $libraries; do ldargs="$ldargs -L $x "; done 
fi;

if [ "plain" = "false" ]; then ldargs="$ldargs -lhush "; fi

if [ "-" != "-$modules" ]; then
for x in $modules; do ldargs="$ldargs -l$x "; done 
fi;
if [ "$dolink" = "true" ]; then ldargs="$ldargs $args"; fi;
ldargs="$ldargs $ldflags ";
fi; ## nolink

if [ "$dolink" != "true" ]; then
if [ "true" = "$verbose" ]; then echo $CC $ccargs $ldargs; fi
$echo $CC $ccargs $ldargs;
if [ "$lib" != "." -a "$nolink" = "false" ]; then
         $echo cp $out $out.exe
	 echo cp $out.exe $lib;
	 cp $out.exe $lib;
	 fi;
else
if [ "$dll" != "nil" ]; then 
	out=lib$dll.so
	ldargs=" -o lib$dll.so -G $ldargs";
fi;
if [ "true" = "$verbose" ]; then echo $LD $ldargs; fi
$echo $LD $ldargs
if [ "$lib" != "." -a "$nolink" = "false" ]; then cp $out $lib; fi;
fi

fi;
