#!/bin/sh
##@ cc-doc

all=false
if [ "$1" = "-" ]; then all="-"; shift; fi;
mode=src
hargs=
jargs=
iargs=
xiargs=
rest=
file=
FH=
FJ=
FI=
verbose=false
omit=false

##@ options

for i do
	T=`@BIN/suffix $i`
	B=`basename $i $B`
	case $i in
	  1) omit=true;;
	  2) ;;
	  -cc) mode=cc;;
	  -idl) mode=idl;;
	  -java) mode=java;;
	  -src) mode=src;;
	  -I*) xiargs="$xiargs $i";;
	  -*) echo "Option: $i ignored";;
	  *.h) if [ -f $i ]; then hargs="$hargs $i"; fi;; 
	  *.java) if [ -f $i ]; then jargs="$jargs $i"; fi;;
	  *.idl)
		if [ ! -n "$file" -a -f $i ]; then
			file=$i;
		elif [ -f $i ]; then
			iargs="$iargs $i"
		fi ;;
	  *)
	     if [ -f $i ]; then rest="$rest $i"; fi;
	     if [ "$verbose" = "true" ]; then
	     	echo "Arg: $i ignored";
	     fi;;
	  esac
done

##@ check args

echo "cc - $hargs"
echo "java - $jargs"
echo "idl - $iargs"
echo "src - $rest"
if [ -n "$hargs" -a \( "$mode" = "src" -o "$mode" = "cc" \) ]; then
	echo "cc-doc $hargs"
	@BIN/dv-doc++ -A -H -i $hargs
	if [ "$omit" = "false" ]; then FH=`ls @h*.ht`; fi;
fi;
if [ -n "$jargs" -a \( "$mode" = "src" -o "$mode" = "java" \) ]; then
	echo "java-doc $jargs"
	@BIN/dv-doc++ -A -J -H -i -m $jargs
	if [ "$omit" = "false" ]; then FJ=`ls @java*.ht`; fi;
fi;
if [ -n "$file" -a \( "$mode" = "src" -o "$mode" = "idl" \) ]; then
	INC="-I. -I.. -I@HUSH/idl -I@CORBA/include"
	echo "idl-doc $xiargs $file"
	@HUSH/bin/dv-idldoc $INC $xiargs $file
	if [ "$omit" = "false" ]; then
		FI=`ls @idl*.ht`;
		for i in $FI; do
	   	sed -e "s:ht#:html#:g" \
		    -e 's:ht>:html>:g' \
		   	$i > $i.bak;
	   	mv $i.bak $i;
		done
	fi;
fi;

##@ and the rest

if [ "$omit" = "false" ]; then F="$FH $FJ $FI"; fi

if [ -n "$FH" -a "$omit" = "false" ]; then 
for i in $FH; do
	echo "ht-ml -  $i"
	@BIN/ht-ml - -notitle -sort cc -loc $i > ${i}ml;
	done
fi

if [ -n "$FJ" -a "$omit" = "false" ]; then 
for i in $FJ; do
	echo "ht-ml -  $i"
	@BIN/ht-ml - -notitle -sort java -loc  $i > ${i}ml;
	done
fi

if [ -n "$FI" -a "$omit" = "false" ]; then 
for i in $F; do
	echo "ht-ml -  $i"
	@BIN/ht-ml - -notitle -sort idl -loc  $i > ${i}ml;
	done
fi
if [ $all = "-" -a "$omit" = "false" ]; then
	echo "src-doc $hargs $jargs $iargs $rest";
	@BIN/src-doc $hargs $jargs $iargs $rest;
	fi

##</>
